<?php

class FrmGetResponseSettingsController {

	public static function add_settings_section( $sections ) {
		$sections['getresponse'] = array(
			'class'    => 'FrmGetResponseSettingsController',
			'function' => 'route',
			'name'     => 'GetResponse',
		);
		return $sections;
	}

	public static function match_fields() {
		check_ajax_referer( 'frmgetresponse_ajax', 'security', true );
		$form_id = isset( $_POST['form_id'] ) ? (int) $_POST['form_id'] : false;
		$list_id = isset( $_POST['list_id'] ) ? sanitize_text_field( wp_unslash( $_POST['list_id'] ) ) : false;
		if ( ! $form_id || ! $list_id ) {
			die();
		}

		$form_fields = FrmField::getAll( 'fi.form_id=' . (int) $form_id . " and fi.type not in ('break', 'divider', 'html', 'captcha', 'form')", 'field_order' );

		if ( isset( $_POST['action_key'] ) ) {
			$action_control = FrmFormActionsController::get_form_actions( 'getresponse' );
			$action_control->_set( sanitize_text_field( wp_unslash( $_POST['action_key'] ) ) );
			include FrmGetResponseAppController::path() . '/views/action-settings/_match_fields.php';
		}

		wp_die();
	}

	public static function register_actions( $actions ) {
		$actions['getresponse'] = 'FrmGetResponseAction';

		include_once FrmGetResponseAppController::path() . '/models/FrmGetResponseAction.php';

		return $actions;
	}

	public static function display_form() {
		$frm_getresponse_settings = new FrmGetResponseSettings();
		$frm_version = FrmAppHelper::plugin_version();

		require_once FrmGetResponseAppController::path() . '/views/settings/form.php';
	}

	public static function process_form() {
		$frm_getresponse_settings = new FrmGetResponseSettings();

		$process_form = FrmAppHelper::get_post_param( 'process_form', '', 'sanitize_text_field' );
		if ( wp_verify_nonce( $process_form, 'process_form_nonce' ) ) {
			$frm_getresponse_settings->update( $_POST );

			$frm_getresponse_settings->store();
			$message = __( 'Settings Saved', 'formidable-getresponse' );
		}

		require_once FrmGetResponseAppController::path() . '/views/settings/form.php';
	}

	public static function route() {
		$action = FrmAppHelper::get_param( 'action' );
		if ( 'process-form' == $action ) {
			return self::process_form();
		} else {
			return self::display_form();
		}
	}
}
